Subject: 27.1; compiler warning if code forgets to require cl-lib

From: "Roland Winkler" <[email-masked]>
Date: Mon, 28 Sep 2020 20:11:27 +0200

Until earlier today, several files in bbdb did not require cl-lib,
when they should have done that.  Nonetheless, bbdb compiled fine
with emacs 25 and 26, but not anymore with emacs 27, see bug #30635.
The goal when fixing #30635 was to issue a warning if a library uses
cl-lib without requiring it.  The problem with bbdb was, however,
that instead the emacs 27 byte compiler threw a rather unhelpful
error message about the cause of the problem.  For bbdb-tex.el, it
said

In bbdb-TeX:
bbdb-tex.el:414:25:Error: Forgot to expand macro cl-progv in ( ...

I suggest that the byte compiler should issue a more helpful warning
about the cause of the problem.

In GNU Emacs 27.1 (build 1, x86_64-pc-linux-gnu, GTK+ Version 3.18.9)
 of 2020-08-31 built on regnitz
Windowing system distributor 'The X.Org Foundation', version 11.0.11804000
System Description: Ubuntu 16.04.7 LTS